-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------
--  Hammer of Justas
--
-- Copyright (C) 2010-2020
-- By Jonathan E. Wright
--
-- FILE: HoJ_DemonHunterSpellInfos.lua
-- DESC: Spell tables for classes

local addonName, HoJ = ...

-- DEFAULT_CHAT_FRAME:AddMessage( "HoJ_DemonHunterSpellInfos.lua" )

-- -------------------------------------------------------------
-- DEMON HUNTER
-- -------------------------------------------------------------
HoJ._demonHunterSpellInfos = {
    ["globalCooldown"] = {
        id = 61304,
        name = HoJ:GetSpellName( 61304 ),
        rank = HoJ:GetSpellRank( 61304 ),
        icon = HoJ:GetSpellIcon( 61304 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_NONE,
    },
    ["consumeMagic"] = {
        id = 278326,
        name = HoJ:GetSpellName( 278326 ),
        rank = HoJ:GetSpellRank( 278326 ),
        icon = HoJ:GetSpellIcon( 278326 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 20,
        range = HoJ.RANGE_30_YARDS,
    },
    -- havoc
    ["demonsBite"] = {
        id = 162243,
        name = HoJ:GetSpellName( 162243 ),
        rank = HoJ:GetSpellRank( 162243 ),
        icon = HoJ:GetSpellIcon( 162243 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 30,
        range = HoJ.RANGE_MELEE,
    },
    ["chaosStrike"] = {
        id = 162794,
        name = HoJ:GetSpellName( 162794 ),
        rank = HoJ:GetSpellRank( 162794 ),
        icon = HoJ:GetSpellIcon( 162794 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = -40,
        range = HoJ.RANGE_MELEE,
    },
    ["eyeBeam"] = {
        id = 198013,
        name = HoJ:GetSpellName( 198013 ),
        rank = HoJ:GetSpellRank( 198013 ),
        icon = HoJ:GetSpellIcon( 198013 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = -30,
        range = HoJ.RANGE_20_YARDS,
    },
    ["bladeDance"] = {
        id = 188499,
        name = HoJ:GetSpellName( 188499 ),
        rank = HoJ:GetSpellRank( 188499 ),
        icon = HoJ:GetSpellIcon( 188499 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = -15,
        range = HoJ.RANGE_15_YARDS,
    },
    ["deathSweep"] = {
        id = 210152,
        name = HoJ:GetSpellName( 210152 ),
        rank = HoJ:GetSpellRank( 210152 ),
        icon = HoJ:GetSpellIcon( 210152 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = -35,
        range = HoJ.RANGE_10_YARDS,
    },
    ["throwGlaive"] = {
        id = 185123,
        name = HoJ:GetSpellName( 185123 ),
        rank = HoJ:GetSpellRank( 185123 ),
        icon = HoJ:GetSpellIcon( 185123 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
    },
    ["felRush"] = {
        id = 195072,
        name = HoJ:GetSpellName( 195072 ),
        rank = HoJ:GetSpellRank( 195072 ),
        icon = HoJ:GetSpellIcon( 195072 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_20_YARDS,
    },
    ["metamorphosis"] = {
        id = 191427,
        name = HoJ:GetSpellName( 191427 ),
        rank = HoJ:GetSpellRank( 191427 ),
        icon = HoJ:GetSpellIcon( 191427 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 30,
        range = HoJ.RANGE_SELF,
    },
    ["metamorphosisBuff"] = {
        id = 162264,
        name = HoJ:GetSpellName( 162264 ),
        rank = HoJ:GetSpellRank( 162264 ),
        icon = HoJ:GetSpellIcon( 162264 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["disrupt"] = {
        id = 183752,
        name = HoJ:GetSpellName( 183752 ),
        rank = HoJ:GetSpellRank( 183752 ),
        icon = HoJ:GetSpellIcon( 183752 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 30,
        range = HoJ.RANGE_MELEE,
    },
    ["vengefulRetreat"] = {
        id = 198793,
        name = HoJ:GetSpellName( 198793 ),
        rank = HoJ:GetSpellRank( 198793 ),
        icon = HoJ:GetSpellIcon( 198793 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["blur"] = {
        id = 198589,
        name = HoJ:GetSpellName( 198589 ),
        rank = HoJ:GetSpellRank( 198589 ),
        icon = HoJ:GetSpellIcon( 198589 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
    },
    ["comsumeMagic"] = {
        id = 278326,
        name = HoJ:GetSpellName( 278326 ),
        rank = HoJ:GetSpellRank( 278326 ),
        icon = HoJ:GetSpellIcon( 278326 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
    },
    ["blurBuff"] = {
        id = 212800,
        name = HoJ:GetSpellName( 212800 ),
        rank = HoJ:GetSpellRank( 212800 ),
        icon = HoJ:GetSpellIcon( 212800 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["imprison"] = {
        id = 217832,
        name = HoJ:GetSpellName( 217832 ),
        rank = HoJ:GetSpellRank( 217832 ),
        icon = HoJ:GetSpellIcon( 217832 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_20_YARDS,
        _creatureTypes = { ["Demon"] = true, ["Beast"] = true, ["Humanoid"] = true }
    },
    -- havoc talents
    ["fellblade"] = {
        id = 232893,
        name = HoJ:GetSpellName( 232893 ),
        rank = HoJ:GetSpellRank( 232893 ),
        icon = HoJ:GetSpellIcon( 232893 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 99,
        cooldownRemaining = 0,
        _powerGen = 40,
        range = HoJ.RANGE_15_YARDS,
        talentRow = 1,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_HAVOC },
    },
    ["demonBlades"] = {
        id = 203555,
        name = HoJ:GetSpellName( 203555 ),
        rank = HoJ:GetSpellRank( 203555 ),
        icon = HoJ:GetSpellIcon( 203555 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _powerGen = 30,
        range = HoJ.RANGE_MELEE,
        talentRow = 2,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_HAVOC },
    },
    ["immolationAura"] = {
        id = 258920,
        name = HoJ:GetSpellName( 258920 ),
        rank = HoJ:GetSpellRank( 258920 ),
        icon = HoJ:GetSpellIcon( 258920 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _powerGen = 30,
        range = HoJ.RANGE_MELEE,
        talentRow = 2,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_HAVOC },
    },
    ["nemesis"] = {
        id = 206491,
        name = HoJ:GetSpellName( 206491 ),
        rank = HoJ:GetSpellRank( 206491 ),
        icon = HoJ:GetSpellIcon( 206491 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 110,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS, -- actually 50 yards
        talentRow = 7,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_HAVOC },
    },
    -- vengeance
    -- SLREMOVE
--[[
    ["vengeanceImmolationAura"] = {
        id = 178740,
        name = HoJ:GetSpellName( 178740 ),
        rank = HoJ:GetSpellRank( 178740 ),
        icon = HoJ:GetSpellIcon( 178740 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 20,
        range = HoJ.RANGE_8_YARDS,
    },
--]]
    ["soulCleave"] = {
        id = 228477,
        name = HoJ:GetSpellName( 228477 ),
        rank = HoJ:GetSpellRank( 228477 ),
        icon = HoJ:GetSpellIcon( 228477 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = -30,
        range = HoJ.RANGE_MELEE,
    },
    ["sigilOfFlame"] = {
        id = 204596,
        name = HoJ:GetSpellName( 204596 ),
        rank = HoJ:GetSpellRank( 204596 ),
        icon = HoJ:GetSpellIcon( 204596 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 20,
        range = HoJ.RANGE_30_YARDS,
    },
    ["shear"] = {
        id = 203783,
        name = HoJ:GetSpellName( 203783 ),
        rank = HoJ:GetSpellRank( 203783 ),
        icon = HoJ:GetSpellIcon( 203783 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 10,
        range = HoJ.RANGE_MELEE,
    },
    ["vengeanceThrowGlaive"] = {
        id = 204157,
        name = HoJ:GetSpellName( 204157 ),
        rank = HoJ:GetSpellRank( 204157 ),
        icon = HoJ:GetSpellIcon( 204157 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
    },
    ["vengeanceMetamorphosis"] = {
        id = 187827,
        name = HoJ:GetSpellName( 187827 ),
        rank = HoJ:GetSpellRank( 187827 ),
        icon = HoJ:GetSpellIcon( 187827 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 105,
        range = HoJ.RANGE_SELF,
    },
    ["vengeanceMetamorphosisBuff"] = {
        id = 187827,
        name = HoJ:GetSpellName( 187827 ),
        rank = HoJ:GetSpellRank( 187827 ),
        icon = HoJ:GetSpellIcon( 187827 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["infernalStrike"] = {
        id = 189110,
        name = HoJ:GetSpellName( 189110 ),
        rank = HoJ:GetSpellRank( 189110 ),
        icon = HoJ:GetSpellIcon( 189110 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS,
    },
    ["sigilOfMisery"] = {
        id = 207684,
        name = HoJ:GetSpellName( 207684 ),
        rank = HoJ:GetSpellRank( 207684 ),
        icon = HoJ:GetSpellIcon( 207684 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
    },
    ["sigilOfSilence"] = {
        id = 202137,
        name = HoJ:GetSpellName( 202137 ),
        rank = HoJ:GetSpellRank( 202137 ),
        icon = HoJ:GetSpellIcon( 202137 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
    },
    ["fieryBrand"] = {
        id = 204021,
        name = HoJ:GetSpellName( 204021 ),
        rank = HoJ:GetSpellRank( 204021 ),
        icon = HoJ:GetSpellIcon( 204021 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
    },
    ["demonSpikes"] = {
        id = 203720,
        name = HoJ:GetSpellName( 203720 ),
        rank = HoJ:GetSpellRank( 203720 ),
        icon = HoJ:GetSpellIcon( 203720 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["demonSpikesBuff"] = {
        id = 203819,
        name = HoJ:GetSpellName( 203819 ),
        rank = HoJ:GetSpellRank( 203819 ),
        icon = HoJ:GetSpellIcon( 203819 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    -- vengeance talents
    ["fracture"] = {
        id = 263642,
        name = HoJ:GetSpellName( 263642 ),
        rank = HoJ:GetSpellRank( 263642 ),
        icon = HoJ:GetSpellIcon( 263642 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 104,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        talentRow = 4,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_VENGEANCE },
    },
    ["sigilOfChains"] = {
        id = 202138,
        name = HoJ:GetSpellName( 202138 ),
        rank = HoJ:GetSpellRank( 202138 ),
        icon = HoJ:GetSpellIcon( 202138 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 106,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
        talentRow = 5,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_VENGEANCE },
    },
    ["spiritBomb"] = {
        id = 247454,
        name = HoJ:GetSpellName( 247454 ),
        rank = HoJ:GetSpellRank( 247454 ),
        icon = HoJ:GetSpellIcon( 247454 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 108,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_25_YARDS,
        talentRow = 6,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_VENGEANCE },
    },
    ["soulFragments"] = {
        id = 203981,
        name = HoJ:GetSpellName( 203981 ),
        rank = HoJ:GetSpellRank( 203981 ),
        icon = HoJ:GetSpellIcon( 203981 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _duration = 20,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_VENGEANCE },
    },
}