-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------
--  Hammer of Justas
--
-- Copyright (C) 2010-2020
-- By Jonathan E. Wright
--
-- FILE: HoJ_Globals.lua
-- DESC: Addon-scope variables.

local addonName, HoJ = ...

-- DEFAULT_CHAT_FRAME:AddMessage( "HoJ_Globals.lua" )

-- HoJ.ADDON_VERSION = 0.5; -- split hopo window from Templar's Verdict window
-- HoJ.ADDON_VERSION = 0.6; -- split icon window from Templar's Verdict window
-- HoJ.ADDON_VERSION = 0.81; -- major rewrite for Mists of Pandaria with low level pally fixes
-- HoJ.ADDON_VERSION = 0.82; -- ret skill bar for rebuke, blinding light, hammer of justice / fist of justice, added selfless healer to buffs, added stack count to buffs and skills. Did not implement skills for Prot yet.
-- HoJ.ADDON_VERSION = 0.9; -- Warlord's of Draenor. Removed skills that no longer exists (inquisition, blinding light)
-- HoJ.ADDON_VERSION = 0.91; -- Warlord's of Draenor, 6.1 skill priority adjustments.
-- HoJ.ADDON_VERSION = 0.92; -- Warlord's of Draenor, 6.2 priorities from Summonstone
HoJ.MAJOR_VERSION = 0 -- Battle for Azeroth, 8.1 Tides of Vengeance

-- HoJ.MINOR_VERSION = 93;
-- HoJ.BUILD_VERSION = 1; -- fixed one of the cooldown button timer texts not being set
-- HoJ.BUILD_VERSION = 2; -- fixed a bug where the crusader strike icon was incorrect if the add-on loaded while in prot spec.
-- HoJ.BUILD_VERSION = 3; -- resetting spell icons was resetting empyrean power to not show as divine storm
-- HoJ.BUILD_VERSION = 4; -- removed debug outputs, first beta
-- HoJ.BUILD_VERSION = 5; -- hammer of wrath fixes, added Shield of Vengeance
-- HoJ.BUILD_VERSION = 6; -- selfless healer cooldown
-- HoJ.BUILD_VERSION = 7; -- BUG: sometimes a rotation skill is shown when everything is on cooldown
-- HoJ.BUILD_TYPE = "beta";
-- HoJ.MINOR_VERSION = 95
-- HoJ.MINOR_VERSION = 96 -- warrior support
HoJ.MINOR_VERSION = 97 -- Shadowlands 

--HoJ.BUILD_VERSION = 0; -- Very basic Protection rotation
-- HoJ.BUILD_VERSION = 1; -- Very basic Protection mitigation cooldowns
-- HoJ.BUILD_VERSION = 2; -- Amortized update logic to smooth out cost per frame.
-- HoJ.BUILD_VERSION = 3; -- renamed some frames, added cooldowns
-- HoJ.BUILD_VERSION = 4; -- added charge counter to rotation cooldown, saved variable versioning
-- HoJ.BUILD_VERSION = 5; -- fixed "predictAhead == nil!" spam during ret mode. That's why this is still in beta...
-- HoJ.BUILD_VERSION = 6; -- added data-driven rotation selection for Retribution
-- HoJ.BUILD_VERSION = 7; -- optimizations
-- HoJ.BUILD_VERSION = 8; -- fixed buff timer caching / inquisition never going away if talented.
-- HoJ.BUILD_VERSION = 9; -- Avenger's Shield will show up as a interrupt skill on the cooldowns list if Rebuke is on CD or out of range
-- HoJ.BUILD_VERSION = 10; -- Hammer of Justice should now show up correctly on cooldowns bar when Fist of Justice is talented
-- HoJ.BUILD_VERSION = 11; -- Fixed 10 yard range being calculated using Fist of Justice when FoJ talent was selected
-- HoJ.BUILD_VERSION = 1 -- 0.95.1 - Added frame alpha configuration to addon menu
-- HoJ.BUILD_VERSION = 2 -- 0.95.2 - tracking of blessing buffs on party members and (as much as possible) on non-party members
-- HoJ.BUILD_VERSION = 3 -- 0.95.3 - cleaned up an accidental nested loop in buff check, fixed issue with max party member being out of range
-- HoJ.BUILD_VERSION = 4 -- 0.95.4 - cleaned up range checks, force empyrean power saved var showOnBar to be true to fix invalid saved state
-- HoJ.BUILD_VERSION = 5 -- 0.95.5 - addon versioning via addon chat channels
-- HoJ.BUILD_VERSION = 6 -- 0.95.6 - fix skill bars showing things when dead
-- HoJ.BUILD_VERSION = 7 -- 0.95.7 - fix for old saved variables not getting reset for Empyrean Power
-- HoJ.BUILD_VERSION = 0 -- 0.96.0 - Major refactor + warrior support
-- HoJ.BUILD_VERSION = 1 -- 0.96.1 - Seraphim fix
-- HoJ.BUILD_VERSION = 2 -- 0.96.2 - Russion localization
-- HoJ.BUILD_VERSION = 3 -- 0.96.3 - Fixed priorities on Battle Shout
-- HoJ.BUILD_VERSION = 4 -- 0.96.4 - Fixed next skill not showing. Fixed misses not incrementing num attackers.
-- HoJ.BUILD_VERSION = 5 -- 0.96.5 - Fixed nil access in damage check
-- HoJ.BUILD_VERSION = 6 -- 0.96.6 - Minor fixes for interrupts in prot (which is otherwise disabled).
-- HoJ.BUILD_VERSION = 7 -- 0.96.7 - Protection warrior rotation support. CheckInteractDistance
-- HoJ.BUILD_VERSION = 8 -- 0.96.8 - Re-enabled paladin blessing checks. Fixed bug with non-spell heal tracking.
-- HoJ.BUILD_VERSION = 9 -- 0.96.9 - Subtlety Rogue rotation.
-- HoJ.BUILD_VERSION = 10 -- 0.96.10 - Havoc Demon Hunter rotation.
-- HoJ.BUILD_VERSION = 0 -- initial fixes for Shadowlands
-- HoJ.BUILD_VERSION = 1 -- word of glory as a cooldown, when selfless healer isn't at 4 stacks and about to die or health low
-- HoJ.BUILD_VERSION = 2 -- word of glory, moment of glory and seraphim for prot paladin
-- HoJ.BUILD_VERSION = 3 -- Fury and Arms warrior fixes for Shadowlands
-- HoJ.BUILD_VERSION = 4 -- Iniquisition fix + Seraphim for Retribution
-- HoJ.BUILD_VERSION = 5 -- Iniquisition removed + Seraphim added to rotation
-- HoJ.BUILD_VERSION = 6 -- Added Final Reckoning to DP cooldowns
-- HoJ.BUILD_VERSION = 7 -- Warrior Arms and Fury fixes
-- HoJ.BUILD_VERSION = 8 -- More Warrior Arms and Fury fixes. Prot warrior enabled.
-- HoJ.BUILD_VERSION = 9 -- Warrior low level whirlwind fix. Arms Warrior rotation from Icy Veins.
-- HoJ.BUILD_VERSION = 10 -- Ret paladin rotation from Icy Veins.
-- HoJ.BUILD_VERSION = 11 -- Added UI scaling.
-- HoJ.BUILD_VERSION = 12 -- Fixed uninitialized _nextSkillBaseTime.
-- HoJ.BUILD_VERSION = 13 -- Updated for 9.0.2 (forgot to bump this value in the code for release)
-- HoJ.BUILD_VERSION = 14 -- Fix UpdateIcons2 to have a larger list to sort up to 10 icons. Removed Warbreaker debug spam.
-- HoJ.BUILD_VERSION = 15 -- Fixed range check on Final Reckoning Cooldown. Fixed HoW not shown during Avenging Wrath. Fixed HoW not in Prot rotation. Added Divine Toll to rotations. Added mana cost checking -- yeah,Mana has been so inconsequental for Ret and Prot over the years the addon never checked it before.
-- HoJ.BUILD_VERSION = 16 -- Fixed GetSpellManaCost error that only showed up on a fresh client login
-- HoJ.BUILD_VERSION = 17 -- Prot prioritize Avenger's Shield at 3+ targets. Simplified some prot checks to use _rangeCheck, _powerCheck. Major fix for 30-yard range checks.
-- HoJ.BUILD_VERSION = 18 -- skipped due to upload issue.
-- HoJ.BUILD_VERSION = 19 -- Fixed an issue where old saved variable data (pre-Shadowlands) could cause errors when spells were re-initialized. In particular this was causing errors on load for warriors if the addon was previously installed for BFA.
-- HoJ.BUILD_VERSION = 20 -- Shadowlands Rogue rotations.
-- HoJ.BUILD_VERSION = 21 -- added Slam to fury rotation for noobs. Fixed some nil accesses in saved variable loading with old profiles.
-- HoJ.BUILD_VERSION = 22 -- fixed Gouge missing from Outlaw rogue priority list.
-- HoJ.BUILD_VERSION = 23 -- fixed some rogue tests for Vanish in rotation. Vanish should no longer be selected if you are tanking the target (since vanish will caush the mob to reset and regain all of its health)
-- HoJ.BUILD_VERSION = 24 -- Fixed numbing poison buff not being detected correctly.
-- HoJ.BUILD_VERSION = 25 -- Made Adrenaline Rush show time remaining on buffs bar.
-- HoJ.BUILD_VERSION = 26 -- Fixed debug spam for Adrenaline Rush missing from Outlaw cooldowns priority list.
-- HoJ.BUILD_VERSION = 27 -- New developer mode to avoid spam. Track spell casts. Don't suggest vanish within 5 seconds of cheap shot.
-- HoJ.BUILD_VERSION = 28 -- removed default power check for Blade Rush. Blade Rush can now be selected as long as energy is < Blade Rush energy cost * 0.25 (this assumes energy skills will be used before Blade Rush's energy gain caps)
-- HoJ.BUILD_VERSION = 29 -- Rogue fixes for Blade Rush, Killing Spree and multi-target. Added Ghostly Strike to rotation. Show Sap in CDs.
HoJ.BUILD_VERSION = 30 -- just updated version in TOC for Shadowlands 9.0.5

-- HoJ.BUILD_TYPE = "Alpha"
HoJ.BUILD_TYPE = "Beta"
-- HoJ.BUILD_TYPE = "Dev" -- some messages will only show for Dev builds

HoJ._savedVersionMajor = HoJ.MAJOR_VERSION
HoJ._savedVersionMinor = HoJ.MINOR_VERSION
HoJ._savedVersionBuild = HoJ.BUILD_VERSION

HoJ._addonPrefix = "HOJ"
HoJ._versionBroadcastInterval = 60 * 5 -- after entering world and every five minutes
HoJ._versionBroadcastNextTime = 0.0
HoJ._versionMessageInterval = 60 * 60 -- once version message has been shown, throttle it to once per hour
HoJ._versionMessageShown = false
HoJ._versionMessageNextTime = 0.0
HoJ._versionBroadcastEnabled = true -- true to send version to other clients
HoJ._versionChecksEnabled = true 	-- true to check versions from other clients and message about new versions

HoJ.POWER_TYPE_MANA = 0
HoJ.POWER_TYPE_RAGE = 1
HoJ.POWER_TYPE_ENERGY = 3
HoJ.POWER_TYPE_HOLY = 9
HoJ.POWER_TYPE_FURY = 17
HoJ.POWER_TYPE_PAIN = 18

HoJ.SPELL_BUFF = 1			-- buffs a unit
HoJ.SPELL_SHAPESHIFT = 2	-- buffs self
HoJ.SPELL_SKILL = 3			-- not a buff, usually part of rotation
HoJ.SPELL_TALENT = 4		-- not a buff, usually part of rotation, but acquired via talents
HoJ.SPELL_TALENT_BUFF = 5	-- a buff that is a spell and talented (selfless healer)
HoJ.SPELL_SKILL_BUFF = 6	-- a skill that when cast gets tracked as a buff, even though it doesn't show up as an aura

HoJ.RANGE_NONE = 1
HoJ.RANGE_SELF = 2
HoJ.RANGE_MELEE = 3
HoJ.RANGE_8_YARDS = 4
HoJ.RANGE_10_YARDS = 5
HoJ.RANGE_12_YARDS = 6
HoJ.RANGE_15_YARDS = 7
HoJ.RANGE_20_YARDS = 8
HoJ.RANGE_25_YARDS = 9
HoJ.RANGE_30_YARDS = 10
HoJ.RANGE_40_YARDS = 11
HoJ.RANGE_100_YARDS = 12
HoJ._rangeNames = { "none", "self", "melee", "8", "10", "12", "15", "20", "25", "30", "40", "100" }

-- paladin
HoJ.ROLE_HEALING = 1
HoJ.ROLE_TANK = 2
HoJ.ROLE_DPS = 3
HoJ.ROLE_UNKNOWN = 4
HoJ.ROLE_ANY = 5 		-- for talents usable by any role

HoJ.SPEC_PALADIN_INITIAL = 5 -- starting spec for paladins
HoJ.SPEC_PALADIN_UNKNOWN = 4 -- no idea what this would be since starting spec is 4
HoJ.SPEC_PALADIN_RETRIBUTION = 3
HoJ.SPEC_PALADIN_PROTECTION = 2
HoJ.SPEC_PALADIN_HOLY = 1

HoJ.SPEC_WARRIOR_ARMS = 1
HoJ.SPEC_WARRIOR_FURY = 2
HoJ.SPEC_WARRIOR_PROTECTION = 3
HoJ.SPEC_WARRIOR_UNKNOWN = 4
HoJ.SPEC_WARRIOR_INITIAL = 5

HoJ.SPEC_ROGUE_ASSASSINATION = 1
HoJ.SPEC_ROGUE_OUTLAW = 2
HoJ.SPEC_ROGUE_SUBTLETY = 3
HoJ.SPEC_ROGUE_UNKNOWN = 4
HoJ.SPEC_ROGUE_INITIAL = 5

HoJ.SPEC_DEMONHUNTER_HAVOC = 1
HoJ.SPEC_DEMONHUNTER_VENGEANCE = 2

HoJ.CLASS_ID_NONE = 0
HoJ.CLASS_ID_PALADIN = 1
HoJ.CLASS_ID_WARRIOR = 2
HoJ.CLASS_ID_ROGUE = 3
HoJ.CLASS_ID_DEMONHUNTER = 4
HoJ.CLASS_ID_OTHER = 999

HoJ.CLASS_NAME_NONE = "NONE"
HoJ.CLASS_NAME_PALADIN = "PALADIN"
HoJ.CLASS_NAME_WARRIOR = "WARRIOR"
HoJ.CLASS_NAME_ROGUE = "ROGUE"
HoJ.CLASS_NAME_DEMONHUNTER = "DEMONHUNTER"

HoJ.SPEC_NAME_WARRIOR_ARMS = "ARMS"
HoJ.SPEC_NAME_WARRIOR_FURY = "FURY"
HoJ.SPEC_NAME_WARRIOR_PROTECTION = "PROTECTION"

HoJ.SPEC_NAME_PALADIN_HOLY = "HOLY"
HoJ.SPEC_NAME_PALADIN_PROTECTION = "PROTECTION"
HoJ.SPEC_NAME_PALADIN_RETRIBUTION = "RETRIBUTION"

HoJ.SPEC_NAME_ROGUE_OUTLAW = "OUTLAW"
HoJ.SPEC_NAME_ROGUE_ASSASSINATION = "ASSASSINATION"
HoJ.SPEC_NAME_ROGUE_SUBTLETY = "SUBTLETY"

HoJ.SPEC_NAME_DEMONHUNTER_HAVOC = "HAVOC"
HoJ.SPEC_NAME_DEMONHUNTER_VENGEANCE = "VENGEANCE"

-- maps a Blizzard class name to a HoJ class id
HoJ._classNameToClassId = {
	[HoJ.CLASS_NAME_PALADIN] = HoJ.CLASS_ID_PALADIN,
	[HoJ.CLASS_NAME_WARRIOR] = HoJ.CLASS_ID_WARRIOR,
	[HoJ.CLASS_NAME_ROGUE] = HoJ.CLASS_ID_ROGUE,
	[HoJ.CLASS_NAME_DEMONHUNTER] = HoJ.CLASS_ID_DEMONHUNTER,
}

-- maps a HoJ class id to a Blizzard class name
HoJ._classIdToClassName = {
	[HoJ.CLASS_ID_NONE] = HoJ.CLASS_NAME_NONE,
	[HoJ.CLASS_ID_PALADIN] = HoJ.CLASS_NAME_PALADIN,
	[HoJ.CLASS_ID_WARRIOR] = HoJ.CLASS_NAME_WARRIOR,
	[HoJ.CLASS_ID_ROGUE] = HoJ.CLASS_NAME_ROGUE,
	[HoJ.CLASS_ID_DEMONHUNTER] = HoJ.CLASS_NAME_DEMONHUNTER,
}

-- maps a HoJ spec name to a Blizzard spec id from GetSpecialization()
HoJ._specNameToSpecId = {
	[HoJ.SPEC_NAME_PALADIN_HOLY] = HoJ.SPEC_PALADIN_HOLY,
	[HoJ.SPEC_NAME_PALADIN_PROTECTION] = HoJ.SPEC_PALADIN_PROTECTION,
	[HoJ.SPEC_NAME_PALADIN_RETRIBUTION] = HoJ.SPEC_PALADIN_RETRIBUTION,

	[HoJ.SPEC_NAME_WARRIOR_ARMS] = HoJ.SPEC_WARRIOR_ARMS,
	[HoJ.SPEC_NAME_WARRIOR_FURY] = HoJ.SPEC_WARRIOR_FURY,
	[HoJ.SPEC_NAME_WARRIOR_PROTECTION] = HoJ.SPEC_WARRIOR_PROTECTION,

	[HoJ.SPEC_NAME_ROGUE_ASSASSINATION] = HoJ.SPEC_ROGUE_ASSASSINATION,
	[HoJ.SPEC_NAME_ROGUE_OUTLAW] = HoJ.SPEC_ROGUE_OUTLAW,
	[HoJ.SPEC_NAME_ROGUE_SUBTLETY] = HoJ.SPEC_ROGUE_SUBTLETY,

	[HoJ.SPEC_NAME_DEMONHUNTER_HAVOC] = HoJ.SPEC_DEMONHUNTER_HAVOC,
	[HoJ.SPEC_NAME_DEMONHUNTER_VENGEANCE] = HoJ.SPEC_DEMONHUNTER_VENGEANCE,
}

-- maps a blizzard spec id from GetSpecialization() for a class to a spec name
-- spec names are used to look up entries for a class spec in the HoJ table.
-- the name is used instead of the spec id so that it can also be used to save
-- to the savedVariables and still be human-readable.
HoJ._specIdToSpecName = {
	[HoJ.CLASS_NAME_PALADIN] = {
		[HoJ.SPEC_PALADIN_HOLY] = HoJ.SPEC_NAME_PALADIN_HOLY,
		[HoJ.SPEC_PALADIN_PROTECTION] = HoJ.SPEC_NAME_PALADIN_PROTECTION,
		[HoJ.SPEC_PALADIN_RETRIBUTION] = HoJ.SPEC_NAME_PALADIN_RETRIBUTION,
		[HoJ.SPEC_PALADIN_UNKNOWN] = HoJ.SPEC_NAME_PALADIN_RETRIBUTION,
		[HoJ.SPEC_PALADIN_INITIAL] = HoJ.SPEC_NAME_PALADIN_RETRIBUTION, -- remap initial to Retribution
	},
	[HoJ.CLASS_NAME_WARRIOR] = {
		[HoJ.SPEC_WARRIOR_ARMS] = HoJ.SPEC_NAME_WARRIOR_ARMS,
		[HoJ.SPEC_WARRIOR_FURY] = HoJ.SPEC_NAME_WARRIOR_FURY,
		[HoJ.SPEC_WARRIOR_PROTECTION] = HoJ.SPEC_NAME_WARRIOR_PROTECTION,
		[HoJ.SPEC_WARRIOR_UNKNOWN] = HoJ.SPEC_NAME_WARRIOR_ARMS, -- ??
		[HoJ.SPEC_WARRIOR_INITIAL] = HoJ.SPEC_NAME_WARRIOR_ARMS, -- remap initial to Arms
	},
	[HoJ.CLASS_NAME_ROGUE] = {
		[HoJ.SPEC_ROGUE_ASSASSINATION] = HoJ.SPEC_NAME_ROGUE_ASSASSINATION,
		[HoJ.SPEC_ROGUE_OUTLAW] = HoJ.SPEC_NAME_ROGUE_OUTLAW,
		[HoJ.SPEC_ROGUE_SUBTLETY] = HoJ.SPEC_NAME_ROGUE_SUBTLETY,
		[HoJ.SPEC_ROGUE_UNKNOWN] = HoJ.SPEC_NAME_ROGUE_ASSASSINATION,
		[HoJ.SPEC_ROGUE_INITIAL] = HoJ.SPEC_NAME_ROGUE_ASSASSINATION,
	},
	[HoJ.CLASS_NAME_DEMONHUNTER] = {
		[HoJ.SPEC_DEMONHUNTER_HAVOC] = HoJ.SPEC_NAME_DEMONHUNTER_HAVOC,
		[HoJ.SPEC_DEMONHUNTER_VENGEANCE] = HoJ.SPEC_NAME_DEMONHUNTER_VENGEANCE,
	},
}

HoJ._classFunctionTable = {
	[HoJ.CLASS_NAME_PALADIN] = {
		_loadFn = nil
	},
	[HoJ.CLASS_NAME_WARRIOR] = {
		_loadFn = nil
	},
	[HoJ.CLASS_NAME_ROGUE] = {
		_loadFn = nil
	},
	[HoJ.CLASS_NAME_DEMONHUNTER] = {
		_loadFn = nil
	},
}

HoJ.STEALTH_ALLOWED  = 0
HoJ.STEALTH_DISALLOWED  = 1
HoJ.STEALTH_REQUIRED = 2

HoJ.THREAT_NONE = -1			-- unit is not in mob's threat table
HoJ.THREAT_OK = 0				-- unit has less than 100% threat for mob (doesn't have aggro)
HoJ.THREAT_AGGRO_PULLED = 1		-- unit has more than 100% threat, but itsn't primary target (tank)
HoJ.THREAT_AGGRO_LOST = 2		-- unit is primary target (tank) but doesn't have aggo
HoJ.THREAT_AGGRO_HELD = 3		-- unit is primary target (tank) and has aggro

HoJ._threatTypeNames = {
	[HoJ.THREAT_NONE] = "NONE",
	[HoJ.THREAT_OK] =  "OK", 
	[HoJ.THREAT_AGGRO_PULLED] = "PULLED",
	[HoJ.THREAT_AGGRO_LOST] =  "LOST", 
	[HoJ.THREAT_AGGRO_HELD] = "HELD"
}

HoJ._threat = HoJ.THREAT_NONE

--DEFAULT_CHAT_FRAME:AddMessage( "HoJ.CLASS_NAME_PALADIN = " .. HoJ.CLASS_NAME_PALADIN )
--DEFAULT_CHAT_FRAME:AddMessage( "classFunctionTable = " .. tostring( HoJ._classFunctionTable ) )
--DEFAULT_CHAT_FRAME:AddMessage( "classFunctionTable[HoJ.CLASS_NAME_PALADIN] = " .. tostring( HoJ[HoJ.CLASS_NAME_PALADIN] ) )
--DEFAULT_CHAT_FRAME:AddMessage( "classFunctionTable[HoJ.CLASS_NAME_PALADIN]._classFunctiontable = " .. tostring( HoJ[HoJ.CLASS_NAME_PALADIN]._classFunctionTable ) )

HoJ._classId = HoJ.CLASS_NONE
HoJ._className = HoJ.CLASS_NAME_NONE
HoJ._defaultSpecId = nil -- based on class is set to a default spec id (pre level 10)
HoJ._classSpecInfo = nil -- reference to table about a class's specs
HoJ._curSpecName = ""
HoJ._curSpecInfo = nil -- reference to the _classSpecInfo sub-table for the current spec
HoJ._specChosen = false -- true if the player has chosen a specialization

-- a minor heal ratio is the ratio of current/max health where a minor heal will
-- show in a rotation.
-- a major heal ratio is the ratio of current/max health where a major heal will
-- show in a rotation.
-- These are global tables for save / load variables and are synced to the
-- curSpecInfo._healRatio on variable load and when a slider is changed.
HoJ.HEAL_NAME_MINOR = "_minorHealHealthRatio"
HoJ.HEAL_NAME_MAJOR = "_majorHealHealthRatio"

--[[
The world state is used to prevents weird stuff from happening between the
time when the player leaves the world and returns (for instance, taking a portal).
I have seen the following happen:
- logged in on a character level 117
- used party sync and leveled to 120
- never logged out
- when taking a portal, on PLAYER_LEAVING_WORLD, UnitLevel( "player" ) returns 117
- after entering the world again, on PLAYER_ENTERING_WORLD, UnitLevel( "player" ) returns 120
- This was messing with blessing initialization.
--]]

HoJ.WORLD_STATE_UNKNOWN = 0
HoJ.WORLD_STATE_LOGGED_IN = 1
HoJ.WORLD_STATE_ENTERED = 2
HoJ.WORLD_STATE_LEFT = 3
HoJ._worldState = HoJ.WORLD_STATE_UNKNOWN

HoJ.REACTION_THRESHOLD = 5 -- 4 will only show skill bar for red mobs, 5 will show skill bar for yellow mobs

HoJ.SKILL_USE_PREDICTION_TIME = 0.01 -- look this far beyond the remaining GCD to predict a skill if we don't have one now

HoJ.ROLE_NAMES = { "HEALING", "TANK", "DPS", "UNKNOWN" }
HoJ.STR_TAB = "	"
HoJ.STR_WHITE = "|cffffffff"
HoJ.STR_YELLOW = "|cffffff00"
HoJ.STR_GREEN = "|cff00ff00"
HoJ.STR_PURPLE = "|cffff00ff"
HoJ.STR_RED = "|cffff0000"
HoJ.STR_ORANGE = "|cffff7f00"
HoJ.STR_LIGHTGRAY = "|cffcfcfcf"
HoJ.STR_GRAY = "|cff7f7f7f"
HoJ.STR_WHISPER = "|cffff7fff"
HoJ.STR_CHANNEL = "|cffffc0c0"

HoJ._initialized = false -- false until HoJ:Initialize() is called the first time
HoJ._finalized = false -- fails until HoJ:Finalize() is called

HoJ._needsReset = true	-- resets occur on role switches
HoJ._spellsChanged = false -- spell book-related things need to be reinitialized

HoJ.GROUP_NONE = 0
HoJ.GROUP_PARTY = 1
HoJ.GROUP_RAID = 2
HoJ._groupType = HoJ.GROUP_NONE
HoJ._numGroupMembers = 1

HoJ._role = HoJ.ROLE_UNKNOWN

HoJ.ADDON_NAME = "" -- HoJ.STR_YELLOW .. "Hammer of Justas" .. HoJ.STR_WHITE
HoJ.MSG_PREFIX = "" -- HoJ.STR_YELLOW .. "Hammer of Justas: " .. HoJ.STR_WHITE
HoJ.UPDATES_PER_SEC = 15
HoJ.RENDERS_PER_SEC = 60
HoJ.UPDATE_INTERVAL = 1.0 / HoJ.UPDATES_PER_SEC
HoJ.RENDER_INTERVAL = 1.0 / HoJ.RENDERS_PER_SEC

-- blessing update amortization
HoJ._partyUpdateIndex = -1 	-- amortizes party buff checks by cycling through party members
HoJ._nextUpdateBlessingFrame = 0
HoJ._updateBlessingsInterval = 1 --HoJ.UPDATES_PER_SEC * 5 -- after finishing a party update, wait this number of extra frames before starting the next

-- don't update everything on the same frame
HoJ.UPDATE_START = 1
HoJ.UPDATE_ROTATION = HoJ.UPDATE_START
HoJ.UPDATE_COOLDOWNS = 2
HoJ.UPDATE_BUFFS = 3
HoJ.UPDATE_MAX = HoJ.UPDATE_BUFFS
HoJ._updateType = HoJ.UPDATE_START

HoJ._nextUpdateTime = 0.0
HoJ._nextRenderTime = 0.0

HoJ._isActive = false
HoJ._inCombat = false
HoJ._combatSessionId = 0
HoJ._sessionCombatStats = { }
HoJ._combatStartTime = 0.0
HoJ._nextSkillBaseTime = -1.0
HoJ._level = 0
HoJ._power = 0
HoJ._powerBarMax = -1.0
HoJ._comboPoints = 0
HoJ._isStealthed = false
HoJ._mana = 0
HoJ._lastPower = 0  -- last player power from UNIT_POWER_UPDATE
HoJ._lastPowerGainTime = 0.0 -- last time power was gained
HoJ._nextPowerGainTime = 0.0 -- predicted next power gain time
HoJ._powerGainInterval = 3.0 -- interval between power gain
HoJ._powerGainStep = 25.0   -- amount of power gain per interval
HoJ._actualPowerPerSec = 0 -- amount of power gained per second, according to Blizzard API
HoJ._predictedPowerPerSec = 0 -- amount of power gained per second, according to prediction -- this accounts for skill-generated power
HoJ._totalPowerGain = 0 -- power gained during the current combat session
HoJ.MAX_HOLY_POWER = 5
HoJ._playerName = nil
HoJ._playerRaceId = 0
HoJ._playerGUID = nil
HoJ._playerInVehicle = false

HoJ._playerHealth = 1
HoJ._playerMaxHealth = 1
HoJ._playerHealthRatio = 1.0

HoJ._averageIncomingDps = 0.0
HoJ._netIncomingDps = 0.0 -- this is positive if we're taking more damage than healing per sec
HoJ._playerTimeToLive = 999.0
HoJ._playerTimeToNearDeath = 999.0

HoJ._incomingDps = 0 -- damage per second taken by the player over the last several seconds
HoJ._healsPerSec = 0
HoJ._incomingDpsRatio = 0.0
HoJ._healsPerSecRatio = 0.0

HoJ._nextHealthTime = 0.0
HoJ._showHealthTime = 0.0	-- set to a time in the future to see health spam

HoJ.HEALTH_SAMPLE_SECONDS = 3 -- number of seconds we keep health history for
HoJ.HEALTH_SAMPLES_PER_SEC = 15	-- number of times per second that we sample health (make sure it's less than HoJ.UPDATE_INTERVAL)

HoJ._frameNum = 0 -- updated for every call to HoJ_OnUpdate
HoJ._updateFrameNum = 0 -- updated for every call to HoJ:Update
HoJ._renderFrameNum = 0 -- updated for every call to HoJ:UpdateRender
HoJ._enteredWorldUpdateFrameNum = 0 -- frame when player entered world, used to gate some udpates after entering world until some things settle
HoJ._updateElapsedTime = 0.0
HoJ._renderElapsedTime = 0.0
HoJ._updateBuffsTime = 0.0 -- when to next check buffs
HoJ._updateCooldownsTime = 0.0 -- when to next check cooldowns
--HoJ._divinePleaTriggerPercentage = 0.75;	-- trigger when we have less than this % of max mana
HoJ._blockedNames = { }	--["testname"] = "testname" };
--HoJ._blockedNames = { ["Mienyu"] = "Mienyu", ["Justas"] = "Justas" };
HoJ._ignoreHistory = { }
HoJ._silentIgnore = false
HoJ._stealthIgnore = true
HoJ._stealthIgnoreMessage = HoJ.STR_CHANNEL .. "[3. WorldDefense] : " .. HoJ.STR_YELLOW .. "Isle of Quel'Danas is under attack!"
HoJ._maxGlowAlpha = 0.5
HoJ._minGlowAlpha = 0.1
HoJ._glowAlpha = HoJ._minGlowAlpha
HoJ._glowScale = 1.025
HoJ._skillCDAlpha = 0.25;	-- alpha for spell icons on cooldown
HoJ._skillNormalAlpha = 0.75	-- alpha for skill icons not on cooldown
HoJ._events = { }
HoJ._HoPo = { nil, nil, nil, nil, nil }
HoJ._HoPoGlow = { nil, nil, nil, nil, nil }
HoJ._curTime = GetTime()
HoJ._rotationTime = HoJ._curTime -- all rotation calculations will use this time, which may be in the future
HoJ._gcdRemaining = 0.0
HoJ._gcdDuration = 0.0 -- we cache this because we can't just query it when a spell isn't active

-- combat dps persist during active combat
HoJ._combatDpsStats = {
	_startTime = 0.0,
	_totalTime = nil, -- unused for combat dps
	_damageDone = 0,
	_attacksHit = 0,
	_attacksHitThreshold = 5,
	_timeThreshold = 5.0,
	_dps = 0.0,
	_maxDps = 0.0,
	_isValid = false,
	_firstPredictedTargetDeathTime = -1.0,
	_predictedTargetDeathTime = -1.0,
}

HoJ._sessionDpsStats = {
	_startTime = nil, -- unused for session dps
	_totalTime = 0.0,
	_damageDone = 0,
	_attacksHit = 0,
	_attacksHitThreshold = 5,
	_timeThreshold = 5.0,
	_dps = 0.0,
	_maxDps = 0.0,
	_isValid = false,
	_firstPredictedTargetDeathTime = -1.0,
	_predictedTargetDeathTime = -1.0,
}

HoJ._targetInfo = {
	_name = ""
}

HoJ._targetExists = false
HoJ._targetCanAttack = false
HoJ._targetCanBeInterrupted = false
HoJ._targetHealth = 0.0
HoJ._targetMaxHealth = 0.0
HoJ._targetHealthRatio = 0.0
HoJ._targetLevel = 1
HoJ._targetClassification = ""
HoJ._targetIsTough = false
HoJ._targetIsBoss = false -- "worldboss" or "rareelite"
HoJ._targetIsFriend = false
HoJ._targetIsPlayer = false
HoJ._targetCreatureType = ""

HoJ._targetInRange = nil	-- one entry for each HoJ.RANGE_ type, indicating if the target is within that range

HoJ._showSkillCDs = true
HoJ._showCooldownsFrame = true
HoJ._showBuffsFrame = true
HoJ._showTemplarsVerdictFrame = true
HoJ._showHolyPowerFrame = true
HoJ._showRotationFrame = true
HoJ._showRotationSecondaryFrame = true
HoJ._showDebugFrame = false

-- this is set by HoJ:InitForDeveloper and will only be true for certain player GUIDs
-- or if "/hoj setDev 1" is executed from the console.
HoJ._isDev = false
HoJ._playerGUID = ""

HoJ._enabled = true;

HoJ.INCOMING_DPS_CHECK_INTERVAL = 2.0
HoJ.AVENGING_WRATH_INCOMING_DPS_RATIO = -0.10	-- incoming DPS less than this ratio will trigger avenging wrath icon
HoJ.AVENGING_WRATH_HEALTH_THRESHOLD = 0.5
HoJ.PROT_GUARDIAN_INCOMING_DPS_RATIO = -0.2 -- incoming DPS less than this will trigger guardian of ancient kings icon

HoJ._buffs = { }	-- list of currently active buffs
HoJ._buffFrames = { }

HoJ._cooldowns = { }	-- list of skills to execute in order of priority / cooldown
HoJ._cooldownFrames = { }

HoJ._rotationSkills = { } -- list of best skills (only ever 1)
HoJ._rotationFrames = { }

HoJ._windowFrames = { }  -- list of all HoJ-specific window frames
HoJ._omniCC = false -- true if omniCC is enabled (it will show it's own timer)

HoJ._globalAlpha = 1.0 -- global alpha for HoJ UI frames
HoJ._rotationAlpha = 1.0
HoJ._rotationSecondaryAlpha = 0.75
HoJ._cooldownsAlpha = 1.0
HoJ._buffsAlpha = 1.0
HoJ._holyPowerAlpha = 1.0
HoJ._debugAlpha = 1.0 
HoJ._uiScale = 1.0

HoJ._debugSpellName = nil -- set to a spell name, e.g. "Wake of Ashes", to debug that spell
HoJ._showRange = false
HoJ._debugBlessings = false
HoJ._debugRulesLevel = 0
HoJ._debugNextSkillLevel = 0
HoJ._debugPower = false
HoJ._debugHealth = false
HoJ._debugThreat = false

HoJ._throttledMessages = { }	-- list of throttled messages

HoJ._recentMeleeAttackers = { }
HoJ._nextRecentMeleeAttackerUpdateFrame = 0
HoJ._numMeleeAttackers = 0
HoJ._lastSpellDamageTime = 0.0

HoJ._controlLost = false
HoJ._hasDebuff = false

HoJ._enableForRetPaladin = true
HoJ._enableForProtPaladin = true
HoJ._enableForRetPaladin = true

-- this table keeps track of major damage skills that have hit the player and is used to
-- later predict when the player should use mitigations.
HoJ._majorDamageSpells = { }

HoJ._aoeExpireTimes = { }

HoJ._inCinematic = false

HoJ._spellIdsToSpellInfos = { }