-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------
--  Hammer of Justas
--
-- Copyright (C) 2010-2020
-- By Jonathan E. Wright
--
-- FILE: HoJ_PaladinSpellInfos.lua
-- DESC: Spell tables for classes

local addonName, HoJ = ...

-- DEFAULT_CHAT_FRAME:AddMessage( "HoJ_PaladinSpellInfos.lua" )

-- -------------------------------------------------------------
-- PALADIN
-- -------------------------------------------------------------
HoJ._paladinSpellInfos = {
    ["divinePurpose"] = {
        id = 223817,
        name = HoJ:GetSpellName( 223817 ),
        rank = HoJ:GetSpellRank( 223817 ),
        icon = HoJ:GetSpellIcon( 223817 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = true,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 7,
        talentCol = 1,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["divinePurposeBuff"] = {
        id = 223819,
        name = HoJ:GetSpellName( 223819 ),
        rank = HoJ:GetSpellRank( 223819 ),
        icon = HoJ:GetSpellIcon( 223819 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = true,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["righteousVerdict"] = {
        id = 267610,
        name = HoJ:GetSpellName( 267610 ),
        rank = HoJ:GetSpellRank( 267610 ),
        icon = HoJ:GetSpellIcon( 267610 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 80,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _duration = 20,
        talentRow = 1,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["righteousVerdictBuff"] = {
        id = 267611,
        name = HoJ:GetSpellName( 267611 ),
        rank = HoJ:GetSpellRank( 267611 ),
        icon = HoJ:GetSpellIcon( 267611 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT_BUFF,
        isProcd = true,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 1,
        talenCol = 2,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["avengingWrath"] = {
        id = 31884,
        name = HoJ:GetSpellName( 31884 ),
        rank = HoJ:GetSpellRank( 31884 ),
        icon = HoJ:GetSpellIcon( 31884 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 37,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _duration = 20,
    },
    ["crusade"] = {
        id = 231895,
        name = HoJ:GetSpellName( 231895 ),
        rank = HoJ:GetSpellRank( 231895 ),
        icon = HoJ:GetSpellIcon( 231895 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 80,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _duration = 20,
        talentRow = 7,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["finalReckoning"] = {
        id = 343721,
        name = HoJ:GetSpellName( 343721 ),
        rank = HoJ:GetSpellRank( 343721 ),
        icon = HoJ:GetSpellIcon( 343721 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
        _duration = 8,
        talentRow = 7,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["holyAvenger"] = {
        id = 105809,
        name = HoJ:GetSpellName( 105809 ),
        rank = HoJ:GetSpellRank( 105809 ),
        icon = HoJ:GetSpellIcon( 105809 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _duration = 20,
        talentRow = 5,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["seraphim"] = {
        id = 152262,
        name = HoJ:GetSpellName( 152262 ),
        rank = HoJ:GetSpellRank( 152262 ),
        icon = HoJ:GetSpellIcon( 152262 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        _showStacks = false,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _powerGen = -3,
        range = HoJ.RANGE_SELF,
        talentRow = 5,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_PROTECTION, HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["seraphimBuff"] = {
        id = 152262,
        name = HoJ:GetSpellName( 152262 ),
        rank = HoJ:GetSpellRank( 152262 ),
        icon = HoJ:GetSpellIcon( 152262 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT_BUFF,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        _showStacks = false,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 5,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_PROTECTION, HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["divineProtection"] = {
        id = 498,
        name = HoJ:GetSpellName( 498 ),
        rank = HoJ:GetSpellRank( 498 ),
        icon = HoJ:GetSpellIcon( 498 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 26,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["ardentDefender"] = {
        id = 31850,
        name = HoJ:GetSpellName( 31850 ),
        rank = HoJ:GetSpellRank( 31850 ),
        icon = HoJ:GetSpellIcon( 31850 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 42,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["shieldOfTheRighteous"] = {
        id = 53600,
        name = HoJ:GetSpellName( 53600 ),
        rank = HoJ:GetSpellRank( 53600 ),
        icon = HoJ:GetSpellIcon( 53600 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 2,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
    },
    ["shieldOfTheRighteousBuff"] = {
        id = 132403,
        name = HoJ:GetSpellName( 132403 ),
        rank = HoJ:GetSpellRank( 132403 ),
        icon = HoJ:GetSpellIcon( 132403 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["consecration"] = {
        id = 26573,
        name = HoJ:GetSpellName( 26573 ),
        rank = HoJ:GetSpellRank( 26573 ),
        icon = HoJ:GetSpellIcon( 26573 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 6,
        cooldownRemaining = 0,
        _powerGen = 1,
        range = HoJ.RANGE_10_YARDS,
        _duration = 12,
        _talentSpecs = { HoJ.SPEC_PALADIN_PROTECTION, HoJ.SPEC_PALADIN_RETRIBUTION },
    },
    ["consecrationBuffRet"] = {
        id = 26573,
        name = HoJ:GetSpellName( 26573 ),
        rank = HoJ:GetSpellRank( 26573 ),
        icon = HoJ:GetSpellIcon( 26573 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 6,
        cooldownRemaining = 0,
        _powerGen = 1,
        range = HoJ.RANGE_10_YARDS,
        _duration = 12,
        _classId = HoJ.CLASS_ID_PALADIN,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION },
        castBySpellId = 26573, -- consecration
    },
    ["consecrationBuffProt"] = {
        id = 188370,
        name = HoJ:GetSpellName( 188370 ),
        rank = HoJ:GetSpellRank( 188370 ),
        icon = HoJ:GetSpellIcon( 188370 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 14,
        cooldownRemaining = 0,
        _powerGen = 1,
        range = HoJ.RANGE_10_YARDS,
        _duration = 12,
        _classId = HoJ.CLASS_ID_PALADIN,
        _talentSpecs = { HoJ.SPEC_PALADIN_PROTECTION },
    },
    ["avengersValor"] = {
        id = 197561,
        name = HoJ:GetSpellName( 197561 ),
        rank = HoJ:GetSpellRank( 197561 ),
        icon = HoJ:GetSpellIcon( 197561 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = true,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 60,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SEKF,
        _duration = 15,
        role = HoJ.ROLE_TANK
    },
    ["guardianOfAncientKings"] = {
        id = 86659,
        name = HoJ:GetSpellName( 86659 ),
        rank = HoJ:GetSpellRank( 86659 ),
        icon = HoJ:GetSpellIcon( 86659 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 39,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["divineShield"] = {
        id = 642,
        name = HoJ:GetSpellName( 642 ),
        rank = HoJ:GetSpellRank( 642 ),
        icon = HoJ:GetSpellIcon( 642 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 6,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["righteousFury"] = {
        id = 25780,
        name = HoJ:GetSpellName( 25780 ),
        rank = HoJ:GetSpellRank( 25780 ),
        icon = HoJ:GetSpellIcon( 25780 ),
        spellIndex = -1,  -- HoJ:GetSpellIndex( 25780 ),
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 12,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["blessingOfProtection"] = {
        id = 1022,
        name = HoJ:GetSpellName( 1022 ),
        rank = HoJ:GetSpellRank( 1022 ),
        icon = HoJ:GetSpellIcon( 1022 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 41,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["blessingOfFreedom"] = {
        id = 1044,
        name = HoJ:GetSpellName( 1044 ),
        rank = HoJ:GetSpellRank( 1044 ),
        icon = HoJ:GetSpellIcon( 1044 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 22,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["blessingOfSacrifice"] = {
        id = 6940,
        name = HoJ:GetSpellName( 6940 ),
        rank = HoJ:GetSpellRank( 6940 ),
        icon = HoJ:GetSpellIcon( 6940 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 32,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["hammerOfWrath"] = {
        id = 24275,
        name = HoJ:GetSpellName( 24275 ),
        rank = HoJ:GetSpellRank( 24275 ),
        icon = HoJ:GetSpellIcon( 24275 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 43,
        cooldownRemaining = 0,
        _powerGen = 1,
        range = HoJ.RANGE_30_YARDS,
    },
    ["hammerOfWrath2"] = { -- rank 2, gained at level 58
        id = 326730,
        name = HoJ:GetSpellName( 326730 ),
        rank = HoJ:GetSpellRank( 326730 ),
        icon = HoJ:GetSpellIcon( 326730 ),
        _cdId = 24275,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 58,
        cooldownRemaining = 0,
        _powerGen = 1,
        range = HoJ.RANGE_30_YARDS,
    },
    ["rebuke"] = {
        id = 96231,
        name = HoJ:GetSpellName( 96231 ),
        rank = HoJ:GetSpellRank( 96231 ),
        icon = HoJ:GetSpellIcon( 96231 ),
        spellIndex = -1,  -- HoJ:GetSpellIndex( 96231 ),
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 23,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE
    },
    ["crusaderStrike"] = {
        id = 35395,
        name = HoJ:GetSpellName( 35395 ),
        rank = HoJ:GetSpellRank( 35395 ),
        icon = HoJ:GetSpellIcon( 35395 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = 1,
        range = HoJ.RANGE_MELEE
    },
    ["judgment"] = {
        id = 20271,
        name = HoJ:GetSpellName( 20271 ),
        rank = HoJ:GetSpellRank( 20271 ),
        icon = HoJ:GetSpellIcon( 20271 ),
        _cdId = 20271,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 3,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS
    },
    ["judgment2"] = {
        id = 327977,
        name = HoJ:GetSpellName( 327977 ),
        rank = HoJ:GetSpellRank( 327977 ),
        icon = HoJ:GetSpellIcon( 327977 ),
        _cdId = 20271,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 8,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS
    },
    ["retJudgment3"] = {
        id = 315867,
        name = HoJ:GetSpellName( 315867 ),
        rank = HoJ:GetSpellRank( 315867 ),
        icon = HoJ:GetSpellIcon( 315867 ),
        _cdId = 20271,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 16,
        cooldownRemaining = 0,
        _powerGen = 1,
        range = HoJ.RANGE_30_YARDS
    },
    ["retJudgment4"] = {
        id = 231663,
        name = HoJ:GetSpellName( 231663 ),
        rank = HoJ:GetSpellRank( 231663 ),
        icon = HoJ:GetSpellIcon( 231663 ),
        _cdId = 20271,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 29,
        cooldownRemaining = 0,
        _powerGen = 1,
        range = HoJ.RANGE_30_YARDS
    },
    ["crusadersJudgment"] = {
        id = 275779,
        name = HoJ:GetSpellName( 275779 ),
        rank = HoJ:GetSpellRank( 275779 ),
        icon = HoJ:GetSpellIcon( 275779 ),
        _cdId = 20271,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 29,
        cooldownRemaining = 0,
        _powerGen = 1,
        range = HoJ.RANGE_30_YARDS
    },
    ["crusadersJudgment2"] = {
        id = 204023,
        name = HoJ:GetSpellName( 204023 ),
        rank = HoJ:GetSpellRank( 204023 ),
        icon = HoJ:GetSpellIcon( 204023 ),
        _cdId = 20271,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 29,
        cooldownRemaining = 0,
        _powerGen = 1,
        range = HoJ.RANGE_30_YARDS
    },
    ["judgmentDebuff"] = {
        id = 197277,
        name = HoJ:GetSpellName( 197277 ),
        rank = HoJ:GetSpellRank( 197277 ),
        icon = HoJ:GetSpellIcon( 197277 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 5,
        cooldownRemaining = 0,
        _powerGen = 1,
        range = HoJ.RANGE_30_YARDS
    },
    ["templarsVerdict"] = {
        id = 85256,
        name = HoJ:GetSpellName( 85256 ),
        rank = HoJ:GetSpellRank( 85256 ),
        icon = HoJ:GetSpellIcon( 85256 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = -3,
        range = HoJ.RANGE_MELEE
    },
    ["templarsVerdictDamage"] = { -- this is the spell we get in the combat log when TV hits an enemy.
        id = 224266,
        name = HoJ:GetSpellName( 224266 ),
        rank = HoJ:GetSpellRank( 224266 ),
        icon = HoJ:GetSpellIcon( 224266 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = -3,
        range = HoJ.RANGE_MELEE
    },
    ["finalVerdict"] = {
        id = 157048,
        name = HoJ:GetSpellName( 157048 ),
        rank = HoJ:GetSpellRank( 157048 ),
        icon = HoJ:GetSpellIcon( 157048 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _powerGen = -3,
        range = HoJ.RANGE_MELEE
    },
    ["finalVerdictBuff"] = {	-- this skill is also the buff...
        id = 157048,
        name = HoJ:GetSpellName( 157048 ),
        rank = HoJ:GetSpellRank( 157048 ),
        icon = HoJ:GetSpellIcon( 157048 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = true,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_NONE
    },
    ["divineStorm"] = {
        id = 53385,
        name = HoJ:GetSpellName( 53385 ),
        rank = HoJ:GetSpellRank( 53385 ),
        icon = HoJ:GetSpellIcon( 53385 ),
        spellIndex = -1,  -- HoJ:GetSpellIndex( 53385 ),
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 23,
        cooldownRemaining = 0,
        _powerGen = -3,
        range = HoJ.RANGE_12_YARDS
    },
    ["executionSentence"] = {
        id = 343527,
        name = HoJ:GetSpellName( 343527 ),
        rank = HoJ:GetSpellRank( 343527 ),
        icon = HoJ:GetSpellIcon( 343527 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 15,
        cooldownRemaining = 0,
        range = HoJ.RANGE_20_YARDS,
        talentRow = 1,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION },
        _powerGen = -3,
    },
    ["lightsHammer"] = {
        id = 114158,
        name = HoJ:GetSpellName( 114158 ),
        rank = HoJ:GetSpellRank( 114158 ),
        icon = HoJ:GetSpellIcon( 114158 ),
        spellIndex = -1,  -- HoJ:GetSpellIndex( 114158 ),
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS
    },
    ["globalCooldown"] = {
        id = 61304,
        name = HoJ:GetSpellName( 61304 ),
        rank = HoJ:GetSpellRank( 61304 ),
        icon = HoJ:GetSpellIcon( 61304 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_NONE
    },
    ["selflessHealer"] = {
        id = 85804,
        name = HoJ:GetSpellName( 85804 ),
        rank = HoJ:GetSpellRank( 85804 ),
        icon = HoJ:GetSpellIcon( 85804 ),
        spellToCast = 19750, -- cast as flash of light
        spellIndex = -1,  -- HoJ:GetSpellIndex( 85804 ),
        spellType = HoJ.SPELL_TALENT_BUFF,
        isProcd = true,
        showOnBar = true, 	-- set to false so we don't show on the buffs bar by default, because we show on cooldowns due to the special circumstances
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 0,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_NONE,
        talentRow = 6,
        talentCol = 1,
        maxBuffCount = 4,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["selflessHealerBuff"] = {
        id = 114250,
        name = HoJ:GetSpellName( 114250 ),
        rank = HoJ:GetSpellRank( 114250 ),
        icon = HoJ:GetSpellIcon( 114250 ),
        spellToCast = 19750, -- cast as flash of light
        spellIndex = -1,  -- HoJ:GetSpellIndex( 85804 ),
        spellType = HoJ.SPELL_BUFF,
        isProcd = true,
        showOnBar = true, 	-- set to false so we don't show on the buffs bar by default, because we show on cooldowns due to the special circumstances
        showCheckbox = true,
        showCharges = false,
        _showStacks = true,
        text = nil,
        minLevel = 0,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_NONE,
        talentRow = 6,
        talentCol = 1,
        maxBuffCount = 4,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["layOnHands"] = {
        id = 633,
        name = HoJ:GetSpellName( 633 ),
        rank = HoJ:GetSpellRank( 633 ),
        icon = HoJ:GetSpellIcon( 633 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 14,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["redemption"] = {
        id = 7328,
        name = HoJ:GetSpellName( 7328 ),
        rank = HoJ:GetSpellRank( 7328 ),
        icon = HoJ:GetSpellIcon( 7328 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 13,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["handOfReckoning"] = {
        id = 62124,
        name = HoJ:GetSpellName( 62124 ),
        rank = HoJ:GetSpellRank( 62124 ),
        icon = HoJ:GetSpellIcon( 62124 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 14,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS
    },
    ["handOfHindrance"] = {
        id = 183218,
        name = HoJ:GetSpellName( 183218 ),
        rank = HoJ:GetSpellRank( 183218 ),
        icon = HoJ:GetSpellIcon( 183218 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 14,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS
    },
    ["turnEvil"] = {
        id = 10326,
        name = HoJ:GetSpellName( 10326 ),
        rank = HoJ:GetSpellRank( 10326 ),
        icon = HoJ:GetSpellIcon( 10326 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 17,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS
    },
    ["divineSteed"] = {
        id = 190784,
        name = HoJ:GetSpellName( 190784 ),
        rank = HoJ:GetSpellRank( 190784 ),
        icon = HoJ:GetSpellIcon( 190784 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 18,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["crusaderAura"] = {
        id = 32223,
        name = HoJ:GetSpellName( 32223 ),
        rank = HoJ:GetSpellRank( 32223 ),
        icon = HoJ:GetSpellIcon( 32223 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 21,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["devotionAura"] = {
        id = 465,
        name = HoJ:GetSpellName( 465 ),
        rank = HoJ:GetSpellRank( 465 ),
        icon = HoJ:GetSpellIcon( 465 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 28,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["retributionAura"] = {
        id = 183435,
        name = HoJ:GetSpellName( 183435 ),
        rank = HoJ:GetSpellRank( 183435 ),
        icon = HoJ:GetSpellIcon( 183435 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 38,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["concentrationAura"] = {
        id = 317920,
        name = HoJ:GetSpellName( 317920 ),
        rank = HoJ:GetSpellRank( 317920 ),
        icon = HoJ:GetSpellIcon( 317920 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 52,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["senseUndead"] = {
        id = 5502,
        name = HoJ:GetSpellName( 5502 ),
        rank = HoJ:GetSpellRank( 5502 ),
        icon = HoJ:GetSpellIcon( 5502 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 54,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_100_YARDS
    },
    ["hammerOfJustice"] = {
        id = 853,
        name = HoJ:GetSpellName( 853 ),
        rank = HoJ:GetSpellRank( 853 ),
        icon = HoJ:GetSpellIcon( 853 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 5,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_10_YARDS
    },
    ["fistOfJustice"] = {
        id = 234299,
        name = HoJ:GetSpellName( 234299 ),
        rank = HoJ:GetSpellRank( 234299 ),
        icon = HoJ:GetSpellIcon( 234299 ),
        iconId = 853,
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_10_YARDS,
        talentRow = 3,
        talentCol = 1,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION, HoJ.SPEC_PALADIN_PROTECTION, HoJ.SPEC_PALADIN_HOLY }
    },
    ["blindingLight"] = {
        id = 115750,
        name = HoJ:GetSpellName( 115750 ),
        rank = HoJ:GetSpellRank( 115750 ),
        icon = HoJ:GetSpellIcon( 115750 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_10_YARDS,
        talentRow = 3,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION, HoJ.SPEC_PALADIN_PROTECTION, HoJ.SPEC_PALADIN_HOLY }
    },
    ["flashOfLight"] = {
        id = 19750,
        name = HoJ:GetSpellName( 19750 ),
        rank = HoJ:GetSpellRank( 19750 ),
        icon = HoJ:GetSpellIcon( 19750 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 4,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["giftOfTheNaaru"] = {
        id = 59542,
        name = HoJ:GetSpellName( 59542 ),
        rank = HoJ:GetSpellRank( 59542 ),
        icon = HoJ:GetSpellIcon( 59542 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS,
        requiredRaceId = 11
    },
    ["wakeOfAshes"] = {
        id = 255937,
        name = HoJ:GetSpellName( 255937 ),
        rank = HoJ:GetSpellRank( 255937 ),
        icon = HoJ:GetSpellIcon( 255937 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 34,
        cooldownRemaining = 0,
        _powerGen = 3,
        range = HoJ.RANGE_12_YARDS,
    },
    ["bladeOfJustice"] = {
        id = 184575,
        name = HoJ:GetSpellName( 184575 ),
        rank = HoJ:GetSpellRank( 184575 ),
        icon = HoJ:GetSpellIcon( 184575 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _powerGen = 2,
        range = HoJ.RANGE_12_YARDS
    },
    ["empyreanPower"] = {
        id = 326732,
        name = HoJ:GetSpellName( 326732 ),
        rank = HoJ:GetSpellRank( 326732 ),
        iconId = 326732,
        icon = HoJ:GetSpellIcon( 326732 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_12_YARDS,
        talentRow = 2,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["empyreanPowerBuff"] = {
        id = 326733,
        name = HoJ:GetSpellName( 326733 ),
        rank = HoJ:GetSpellRank( 326733 ),
        -- iconId = 326732, -- shows the empyrean power icon in the skill window
        icon = HoJ:GetSpellIcon( 326733 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_12_YARDS
    },
    ["wordOfGlory"] = {
        id = 85673,
        name = HoJ:GetSpellName( 85673 ),
        rank = HoJ:GetSpellRank( 85673 ),
        icon = HoJ:GetSpellIcon( 85673 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 7,
        cooldownRemaining = 0,
        _powerGen = -3,
        range = HoJ.RANGE_40_YARDS,
    },
    ["justicarsVengeance"] = {
        id = 215661,
        name = HoJ:GetSpellName( 215661 ),
        rank = HoJ:GetSpellRank( 215661 ),
        icon = HoJ:GetSpellIcon( 215661 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _powerGen = -5,
        range = HoJ.RANGE_40_YARDS,
        talentRow = 6,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["shieldOfVengeance"] = {
        id = 184662,
        name = HoJ:GetSpellName( 184662 ),
        rank = HoJ:GetSpellRank( 184662 ),
        icon = HoJ:GetSpellIcon( 184662 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 26,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["avengersShield"] = {
        id = 31935,
        name = HoJ:GetSpellName( 31935 ),
        rank = HoJ:GetSpellRank( 31935 ),
        icon = HoJ:GetSpellIcon( 31935 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["hammerOfTheRighteous"] = {
        id = 53595,
        name = HoJ:GetSpellName( 53595 ),
        rank = HoJ:GetSpellRank( 53595 ),
        icon = HoJ:GetSpellIcon( 53595 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
    },
    ["blessedHammer"] = {
        id = 204019,
        name = HoJ:GetSpellName( 204019 ),
        rank = HoJ:GetSpellRank( 204019 ),
        icon = HoJ:GetSpellIcon( 204019 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 15,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_10_YARDS, -- this is a rough guess, but it appears to be about the same as Hammer of Justice
        talentRow = 1,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_PROTECTION }
    },
    ["forbearance"] = {
        id = 25771,
        name = HoJ:GetSpellName( 25771 ),
        rank = HoJ:GetSpellRank( 25771 ),
        icon = HoJ:GetSpellIcon( 25771 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 15,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["repentance"] = {
        id = 20066,
        name = HoJ:GetSpellName( 20066 ),
        rank = HoJ:GetSpellRank( 20066 ),
        icon = HoJ:GetSpellIcon( 20066 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
        talentRow = 3,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_PALADIN_HOLY, HoJ.SPEC_PALADIN_PROTECTION, HoJ.SPEC_PALADIN_RETRIBUTION },
        _creatureTypes = { ["Demon"] = true, ["Humanoid"] = true, ["Undead"] = true, ["Dragonkin"] = true, ["Giant"] = true }
    },
    ["momentOfGlory"] = {
        id = 327193,
        name = HoJ:GetSpellName( 327193 ),
        rank = HoJ:GetSpellRank( 327193 ),
        icon = HoJ:GetSpellIcon( 327193 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 25,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 2,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_PROTECTION }
    },
    ["shiningLight"] = {
        id = 321136,
        name = HoJ:GetSpellName( 321136 ),
        rank = HoJ:GetSpellRank( 321136 ),
        icon = HoJ:GetSpellIcon( 321136 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL, -- passive
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 47,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["shiningLightBuff"] = {
        id = 182104,
        name = HoJ:GetSpellName( 182104 ),
        rank = HoJ:GetSpellRank( 182104 ),
        icon = HoJ:GetSpellIcon( 182104 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = true,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        _showStacks = true,
        text = nil,
        minLevel = 47,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["divineToll"] = {
        id = 304971,
        name = HoJ:GetSpellName( 304971 ),
        rank = HoJ:GetSpellRank( 304971 ),
        icon = HoJ:GetSpellIcon( 304971 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        _showStacks = false,
        text = nil,
        minLevel = 60,
        cooldownRemaining = 0,
        _powerGen = 1,
        range = HoJ.RANGE_30_YARDS
    },
}
