-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------
--  Hammer of Justas
--
-- Copyright (C) 2010-2020
-- By Jonathan E. Wright
--
-- FILE: HoJ_RogueSpellInfos.lua
-- DESC: Spell tables for rogue class

local addonName, HoJ = ...

-- DEFAULT_CHAT_FRAME:AddMessage( "HoJ_RogueSpellInfos.lua" )

-- -------------------------------------------------------------
-- ROGUE
-- -------------------------------------------------------------
HoJ._rogueSpellInfos = {
    ["globalCooldown"] = {
        id = 61304,
        name = HoJ:GetSpellName( 61304 ),
        rank = HoJ:GetSpellRank( 61304 ),
        icon = HoJ:GetSpellIcon( 61304 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_NONE,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["ambush"] = {
        id = 8676,
        name = HoJ:GetSpellName( 8676 ),
        rank = HoJ:GetSpellRank( 8676 ),
        icon = HoJ:GetSpellIcon( 8676 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 7,
        cooldownRemaining = 0,
        _powerGen = -45,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY, HoJ.SPEC_ROGUE_OUTLAW, HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    -- id 1752 is used by un-specced rogues
    ["sinisterStrike"] = {
        id = 1752,
        name = HoJ:GetSpellName( 1752 ),
        rank = HoJ:GetSpellRank( 1752 ),
        icon = HoJ:GetSpellIcon( 1752 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = -45,
        _comboGen = 1,
        range = HoJ.RANGE_8_YARDS,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["sinisterStrike2Assassination"] = {
        id = 279877,
        name = HoJ:GetSpellName( 279877 ),
        rank = HoJ:GetSpellRank( 279877 ),
        icon = HoJ:GetSpellIcon( 279877 ),
        _cdId = 1752,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = -45,
        _comboGen = 1,
        range = HoJ.RANGE_8_YARDS,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = {HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["sinisterStrikeOutlaw"] = {
        id = 193315,
        name = HoJ:GetSpellName( 193315 ),
        rank = HoJ:GetSpellRank( 193315 ),
        icon = HoJ:GetSpellIcon( 193315 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = -45,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = {HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["sinisterStrike2Outlaw"] = {
        id = 279876,
        name = HoJ:GetSpellName( 279876 ),
        rank = HoJ:GetSpellRank( 279876 ),
        icon = HoJ:GetSpellIcon( 279876 ),
        _cdId = 193315,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = -45,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = {HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["rollTheBones"] = {
        id = 315508,
        name = HoJ:GetSpellName( 315508 ),
        rank = HoJ:GetSpellRank( 315508 ),
        icon = HoJ:GetSpellIcon( 315508 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 29, 
        cooldownRemaining = 0,
        _powerGen = -25,
        _comboGen = 1,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _breaksStealth = false,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["eviscerate"] = {
        id = 196819,
        name = HoJ:GetSpellName( 196819 ),
        rank = HoJ:GetSpellRank( 196819 ),
        icon = HoJ:GetSpellIcon( 196819 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 2,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = -6,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY, HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["eviscerate2"] = {
        id = 231716,
        name = HoJ:GetSpellName( 231716 ),
        rank = HoJ:GetSpellRank( 231716 ),
        icon = HoJ:GetSpellIcon( 231716 ),
        _cdId = 196819,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 3,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = -6,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["envenom"] = {
        id = 32645,
        name = HoJ:GetSpellName( 32645 ),
        rank = HoJ:GetSpellRank( 32645 ),
        icon = HoJ:GetSpellIcon( 32645 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 22,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = -6,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["sliceAndDice"] = {
        id = 315496,
        name = HoJ:GetSpellName( 315496 ),
        rank = HoJ:GetSpellRank( 315496 ),
        icon = HoJ:GetSpellIcon( 315496 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 9,
        cooldownRemaining = 0,
        _powerGen = -25,
        _comboGen = -6,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
    },
    ["sliceAndDice2"] = {
        id = 344362,
        name = HoJ:GetSpellName( 344362 ),
        rank = HoJ:GetSpellRank( 344362 ),
        icon = HoJ:GetSpellIcon( 344362 ),
        _cdId = 315496,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 9,
        cooldownRemaining = 0,
        _powerGen = -25,
        _comboGen = -6,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["betweenTheEyes"] = {
        id = 315341,
        name = HoJ:GetSpellName( 315341 ),
        rank = HoJ:GetSpellRank( 315341 ),
        icon = HoJ:GetSpellIcon( 315341 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 17,
        cooldownRemaining = 0,
        _powerGen = -25,
        _comboGen = -6,
        range = HoJ.RANGE_20_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["dispatch"] = {
        id = 2098,
        name = HoJ:GetSpellName( 2098 ),
        rank = HoJ:GetSpellRank( 2098 ),
        icon = HoJ:GetSpellIcon( 2098 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 22,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = -6,
        range = HoJ.RANGE_8_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["stealth"] = {
        id = 1784,
        name = HoJ:GetSpellName( 1784 ),
        rank = HoJ:GetSpellRank( 1784 ),
        icon = HoJ:GetSpellIcon( 1784 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 3,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = -6,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["cheapShot"] = {
        id = 1833,
        name = HoJ:GetSpellName( 1833 ),
        rank = HoJ:GetSpellRank( 1833 ),
        icon = HoJ:GetSpellIcon( 1833 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 3,
        cooldownRemaining = 0,
        _powerGen = -40,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_REQUIRED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY, HoJ.SPEC_ROGUE_OUTLAW, HoJ.SPEC_ROGUE_ASSASSINATION },
        _duration = 4.0,
    },
    ["deadlyPoison"] = {
        id = 2823,
        name = HoJ:GetSpellName( 2823 ),
        rank = HoJ:GetSpellRank( 2823 ),
        icon = HoJ:GetSpellIcon( 2823 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _showTimeThreshold = 120,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["deadlyPoison2"] = {
        id = 315584,
        name = HoJ:GetSpellName( 315584 ),
        rank = HoJ:GetSpellRank( 315584 ),
        icon = HoJ:GetSpellIcon( 315584 ),
        _cdId = 2823,
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _showTimeThreshold = 120,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["poisonedKnife"] = {
        id = 185565,
        name = HoJ:GetSpellName( 185565 ),
        rank = HoJ:GetSpellRank( 185565 ),
        icon = HoJ:GetSpellIcon( 185565 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 29,
        cooldownRemaining = 0,
        _powerGen = -40,
        _comboGen = 1,
        range = HoJ.RANGE_30_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["pistolShot"] = {
        id = 185763,
        name = HoJ:GetSpellName( 185763 ),
        rank = HoJ:GetSpellRank( 185763 ),
        icon = HoJ:GetSpellIcon( 185763 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = -40,
        _comboGen = 1,
        range = HoJ.RANGE_20_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["grapplingHook"] = {
        id = 195457,
        name = HoJ:GetSpellName( 195457 ),
        rank = HoJ:GetSpellRank( 195457 ),
        icon = HoJ:GetSpellIcon( 195457 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 18,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 1,
        range = HoJ.RANGE_40_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["garrote"] = {
        id = 703,
        name = HoJ:GetSpellName( 703 ),
        rank = HoJ:GetSpellRank( 703 ),
        icon = HoJ:GetSpellIcon( 703 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 12,
        cooldownRemaining = 0,
        _powerGen = -45,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["garrote2"] = {
        id = 231719,
        name = HoJ:GetSpellName( 231719 ),
        rank = HoJ:GetSpellRank( 231719 ),
        icon = HoJ:GetSpellIcon( 231719 ),
        _cdId = 703,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 12,
        cooldownRemaining = 0,
        _powerGen = -45,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["pickPocket"] = {
        id = 921,
        name = HoJ:GetSpellName( 921 ),
        rank = HoJ:GetSpellRank( 921 ),
        icon = HoJ:GetSpellIcon( 921 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 24,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_10_YARDS,
        _stealth = HoJ.STEALTH_REQUIRED
    },
    ["sap"] = {
        id = 6770,
        name = HoJ:GetSpellName( 6770 ),
        rank = HoJ:GetSpellRank( 6770 ),
        icon = HoJ:GetSpellIcon( 6770 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 11,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 0,
        range = HoJ.RANGE_10_YARDS,
        _stealth = HoJ.STEALTH_REQUIRED,
        _creatureTypes = { ["Demon"] = true, ["Beast"] = true, ["Humanoid"] = true, ["Dragonkin"] = true }
    },
    ["crimsonVial"] = {
        id = 185311,
        name = HoJ:GetSpellName( 185311 ),
        rank = HoJ:GetSpellRank( 185311 ),
        icon = HoJ:GetSpellIcon( 185311 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 8,
        cooldownRemaining = 0,
        _powerGen = -30,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["kick"] = {
        id = 1766,
        name = HoJ:GetSpellName( 1766 ),
        rank = HoJ:GetSpellRank( 1766 ),
        icon = HoJ:GetSpellIcon( 1766 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 16,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_8_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["rupture"] = {
        id = 1943,
        name = HoJ:GetSpellName( 1943 ),
        rank = HoJ:GetSpellRank( 1943 ),
        icon = HoJ:GetSpellIcon( 1943 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 17,
        cooldownRemaining = 0,
        _powerGen = -25,
        _comboGen = -6,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
        _durationForComboPoints = {
            8,
            12,
            16,
            20,
            24,
            28
        }
    },
    ["shadowstep"] = {
        id = 36554,
        name = HoJ:GetSpellName( 36554 ),
        rank = HoJ:GetSpellRank( 36554 ),
        icon = HoJ:GetSpellIcon( 36554 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 18,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_25_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _breaksStealth = false,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["blind"] = {
        id = 2094,
        name = HoJ:GetSpellName( 2094 ),
        rank = HoJ:GetSpellRank( 2094 ),
        icon = HoJ:GetSpellIcon( 2094 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 39,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_15_YARDS,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY, HoJ.SPEC_ROGUE_OUTLAW, HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["pickLock"] = {
        id = 1804,
        name = HoJ:GetSpellName( 1804 ),
        rank = HoJ:GetSpellRank( 1804 ),
        icon = HoJ:GetSpellIcon( 1804 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 14,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["evasion"] = {
        id = 5277,
        name = HoJ:GetSpellName( 5277 ),
        rank = HoJ:GetSpellRank( 5277 ),
        icon = HoJ:GetSpellIcon( 5277 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 21,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["evasion2"] = {
        id = 344363,
        name = HoJ:GetSpellName( 344363 ),
        rank = HoJ:GetSpellRank( 344363 ),
        icon = HoJ:GetSpellIcon( 344363 ),
        _cdId = 5277,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 21,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW }
    },
    ["sprint"] = {
        id = 315496,
        name = HoJ:GetSpellName( 315496 ),
        rank = HoJ:GetSpellRank( 315496 ),
        icon = HoJ:GetSpellIcon( 315496 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 5,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["sprint2"] = {
        id = 2983,
        name = HoJ:GetSpellName( 2983 ),
        rank = HoJ:GetSpellRank( 2983 ),
        icon = HoJ:GetSpellIcon( 2983 ),
        _cdId = 315496,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 31,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["kidneyShot"] = {
        id = 408,
        name = HoJ:GetSpellName( 408 ),
        rank = HoJ:GetSpellRank( 408 ),
        icon = HoJ:GetSpellIcon( 408 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 13,
        cooldownRemaining = 0,
        _powerGen = -25,
        _comboGen = 0,
        range = HoJ.RANGE_8_YARDS,
        _requiresStealth = false,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY, HoJ.SPEC_ROGUE_OUTLAW, HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["gouge"] = {
        id = 1776,
        name = HoJ:GetSpellName( 1776 ),
        rank = HoJ:GetSpellRank( 1776 ),
        icon = HoJ:GetSpellIcon( 1776 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 46,
        cooldownRemaining = 0,
        _powerGen = -25,
        _comboGen = 0,
        range = HoJ.RANGE_8_YARDS,
        _requiresStealth = false,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["distract"] = {
        id = 1725,
        name = HoJ:GetSpellName( 1725 ),
        rank = HoJ:GetSpellRank( 1725 ),
        icon = HoJ:GetSpellIcon( 1725 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 28,
        cooldownRemaining = 0,
        _powerGen = -30,
        _comboGen = 0,
        range = HoJ.RANGE_30_YARDS,
        _stealth = HoJ.STEALTH_REQUIRED
    },
    ["instantPoison"] = {
        id = 315584,
        name = HoJ:GetSpellName( 315584 ),
        rank = HoJ:GetSpellRank( 315584 ),
        icon = HoJ:GetSpellIcon( 315584 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 6, -- actuall granted by a quest
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _showTimeThreshold = 120,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["cripplingPoison"] = {
        id = 3408,
        name = HoJ:GetSpellName( 3408 ),
        rank = HoJ:GetSpellRank( 3408 ),
        icon = HoJ:GetSpellIcon( 3408 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 33,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _showTimeThreshold = 120
    },
    ["numbingPoison"] = {
        id = 5761,
        name = HoJ:GetSpellName( 5761 ),
        rank = HoJ:GetSpellRank( 5761 ),
        icon = HoJ:GetSpellIcon( 5761 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 54,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _showTimeThreshold = 120
    },
    ["mutilate"] = {
        id = 1329,
        name = HoJ:GetSpellName( 1329 ),
        rank = HoJ:GetSpellRank( 1329 ),
        icon = HoJ:GetSpellIcon( 1329 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _powerGen = -50,
        _comboGen = 2,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["feint"] = {
        id = 1966,
        name = HoJ:GetSpellName( 1966 ),
        rank = HoJ:GetSpellRank( 1966 ),
        icon = HoJ:GetSpellIcon( 1966 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 34,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["vanish"] = {
        id = 1856,
        name = HoJ:GetSpellName( 1856 ),
        rank = HoJ:GetSpellRank( 1856 ),
        icon = HoJ:GetSpellIcon( 1856 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 23,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["woundPoison"] = {
        id = 8679,
        name = HoJ:GetSpellName( 8679 ),
        rank = HoJ:GetSpellRank( 8679 ),
        icon = HoJ:GetSpellIcon( 8679 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 38,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _showTimeThreshold = 120,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY, HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["vendetta"] = {
        id = 79140,
        name = HoJ:GetSpellName( 79140 ),
        rank = HoJ:GetSpellRank( 79140 ),
        icon = HoJ:GetSpellIcon( 79140 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 56,
        cooldownRemaining = 0,
        _powerGen = 60,
        _comboGen = 0,
        range = HoJ.RANGE_30_YARDS,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = {HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["fanOfKnives"] = {
        id = 51723,
        name = HoJ:GetSpellName( 51723 ),
        rank = HoJ:GetSpellRank( 51723 ),
        icon = HoJ:GetSpellIcon( 51723 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 63,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 1,
        range = HoJ.RANGE_10_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = {HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["bladeFlurry"] = {
        id = 13877,
        name = HoJ:GetSpellName( 13877 ),
        rank = HoJ:GetSpellRank( 13877 ),
        icon = HoJ:GetSpellIcon( 13877 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 19,
        cooldownRemaining = 0,
        _powerGen = -15,
        _comboGen = 1,
        range = HoJ.RANGE_10_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = {HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["bladeFlurry2"] = {
        id = 331851,
        name = HoJ:GetSpellName( 331851 ),
        rank = HoJ:GetSpellRank( 331851 ),
        icon = HoJ:GetSpellIcon( 331851 ),
        _cdId = 13877,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 52,
        cooldownRemaining = 0,
        _powerGen = -15,
        _comboGen = 1,
        range = HoJ.RANGE_10_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = {HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["shroudOfConcealment"] = {
        id = 114018,
        name = HoJ:GetSpellName( 114018 ),
        rank = HoJ:GetSpellRank( 114018 ),
        icon = HoJ:GetSpellIcon( 114018 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 49,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_30_YARDS,
        _stealth = HoJ.STEALTH_REQUIRED,
    },
    ["tricksOfTheTrade"] = {
        id = 57934,
        name = HoJ:GetSpellName( 57934 ),
        rank = HoJ:GetSpellRank( 57934 ),
        icon = HoJ:GetSpellIcon( 57934 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 48,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_100_YARDS,
        _stealth = HoJ.STEALTH_ALLOWED,
    },
    ["cloakOfShadows"] = {
        id = 31224,
        name = HoJ:GetSpellName( 31224 ),
        rank = HoJ:GetSpellRank( 31224 ),
        icon = HoJ:GetSpellIcon( 31224 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 47,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["shiv"] = {
        id = 5938,
        name = HoJ:GetSpellName( 5938 ),
        rank = HoJ:GetSpellRank( 5938 ),
        icon = HoJ:GetSpellIcon( 5938 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 32,
        cooldownRemaining = 0,
        _powerGen = -20,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_ALLOWED,
    },
    ["shiv2"] = {
        id = 319032,
        name = HoJ:GetSpellName( 319032 ),
        rank = HoJ:GetSpellRank( 319032 ),
        icon = HoJ:GetSpellIcon( 319032 ),
        _cdId = 5938,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 32,
        cooldownRemaining = 0,
        _powerGen = -20,
        _comboGen = 2,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = {HoJ.SPEC_ROGUE_ASSASSINATION },
    },
    ["backstab"] = {
        id = 53,
        name = HoJ:GetSpellName( 53 ),
        rank = HoJ:GetSpellRank( 53 ),
        icon = HoJ:GetSpellIcon( 53 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 14,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["backstab2"] = {
        id = 319949,
        name = HoJ:GetSpellName( 319949 ),
        rank = HoJ:GetSpellRank( 319949 ),
        icon = HoJ:GetSpellIcon( 319949 ),
        _cdId = 53,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 46,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["shurikenToss"] = {
        id = 114014,
        name = HoJ:GetSpellName( 114014 ),
        rank = HoJ:GetSpellRank( 114014 ),
        icon = HoJ:GetSpellIcon( 114014 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 16,
        cooldownRemaining = 0,
        _powerGen = -40,
        _comboGen = 1,
        range = HoJ.RANGE_30_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["shadowstrike"] = {
        id = 185438,
        name = HoJ:GetSpellName( 185438 ),
        rank = HoJ:GetSpellRank( 185438 ),
        icon = HoJ:GetSpellIcon( 185438 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 12,
        cooldownRemaining = 0,
        _powerGen = -40,
        _comboGen = 2,
        range = HoJ.RANGE_25_YARDS,
        _stealth = HoJ.STEALTH_REQUIRED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["shadowstrike2"] = {
        id = 231718,
        name = HoJ:GetSpellName( 231718 ),
        rank = HoJ:GetSpellRank( 231718 ),
        icon = HoJ:GetSpellIcon( 231718 ),
        _cdId = 185438,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 38,
        cooldownRemaining = 0,
        _powerGen = -40,
        _comboGen = 2,
        range = HoJ.RANGE_25_YARDS,
        _stealth = HoJ.STEALTH_REQUIRED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
--[[
    ["nightblade"] = {
        id = 195452,
        name = HoJ:GetSpellName( 195452 ),
        rank = HoJ:GetSpellRank( 195452 ),
        icon = HoJ:GetSpellIcon( 195452 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _powerGen = -25,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
    },
    ["nightbladeDebuff"] = {
        id = 195452,
        name = HoJ:GetSpellName( 195452 ),
        rank = HoJ:GetSpellRank( 195452 ),
        icon = HoJ:GetSpellIcon( 195452 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _durationForComboPoints = {
            8,
            10,
            12,
            14,
            16,
            18
        }
    },
--]]
    ["symbolsOfDeath"] = {
        id = 212283,
        name = HoJ:GetSpellName( 212283 ),
        rank = HoJ:GetSpellRank( 212283 ),
        icon = HoJ:GetSpellIcon( 212283 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 29,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _breaksStealth = false,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["symbolsOfDeath2"] = {
        id = 328077,
        name = HoJ:GetSpellName( 328077 ),
        rank = HoJ:GetSpellRank( 328077 ),
        icon = HoJ:GetSpellIcon( 328077 ),
        _cdId = 212283,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 43,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _breaksStealth = false,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["symbolsOfDeathBuff"] = {
        id = 212283,
        name = HoJ:GetSpellName( 212283 ),
        rank = HoJ:GetSpellRank( 212283 ),
        icon = HoJ:GetSpellIcon( 212283 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 36,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
    },
    ["shadowDance"] = {
        id = 185313,
        name = HoJ:GetSpellName( 185313 ),
        rank = HoJ:GetSpellRank( 185313 ),
        icon = HoJ:GetSpellIcon( 185313 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 22,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["shadowDanceBuff"] = {
        id = 185422,
        name = HoJ:GetSpellName( 185422 ),
        rank = HoJ:GetSpellRank( 185422 ),
        icon = HoJ:GetSpellIcon( 185422 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
    },
    ["shadowBlades"] = {
        id = 121471,
        name = HoJ:GetSpellName( 121471 ),
        rank = HoJ:GetSpellRank( 121471 ),
        icon = HoJ:GetSpellIcon( 121471 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 42,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _breaksStealth = false,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["adrenalineRush"] = {
        id = 13750,
        name = HoJ:GetSpellName( 13750 ),
        rank = HoJ:GetSpellRank( 13750 ),
        icon = HoJ:GetSpellIcon( 13750 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 42,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 1,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["shurikenStorm"] = {
        id = 197835,
        name = HoJ:GetSpellName( 197835 ),
        rank = HoJ:GetSpellRank( 197835 ),
        icon = HoJ:GetSpellIcon( 197835 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 19,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 1,
        _comboGenPerAttacker = 1,
        _comboGenMax = 8,
        range = HoJ.RANGE_10_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["shurikenStorm2"] = {
        id = 319951,
        name = HoJ:GetSpellName( 319951 ),
        rank = HoJ:GetSpellRank( 319951 ),
        icon = HoJ:GetSpellIcon( 319951 ),
        _cdId = 197835,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 58,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 1,
        _comboGenPerAttacker = 1,
        _comboGenMax = 8,
        range = HoJ.RANGE_10_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["gloomblade"] = {
        id = 200758,
        name = HoJ:GetSpellName( 200758 ),
        rank = HoJ:GetSpellRank( 200758 ),
        icon = HoJ:GetSpellIcon( 200758 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 15,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 1,
        range = HoJ.RANGE_8_YARDS,
        talentRow = 1,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["markedForDeath"] = {
        id = 137619,
        name = HoJ:GetSpellName( 137619 ),
        rank = HoJ:GetSpellRank( 137619 ),
        icon = HoJ:GetSpellIcon( 137619 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_30_YARDS,
        talentRow = 3,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY, HoJ.SPEC_ROGUE_ASSASSINATION, HoJ.SPEC_ROGUE_OUTLAW },
        _stealth = HoJ.STEALTH_ALLOWED,
        _breaksStealth = false
    },
    ["deeperStrategem"] = {
        id = 193531,
        name = HoJ:GetSpellName( 193531 ),
        rank = HoJ:GetSpellRank( 193531 ),
        icon = HoJ:GetSpellIcon( 193531 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 3,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["secretTechnique"] = {
        id = 280719,
        name = HoJ:GetSpellName( 280719 ),
        rank = HoJ:GetSpellRank( 280719 ),
        icon = HoJ:GetSpellIcon( 280719 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = -30,
        _comboGen = 0,
        range = HoJ.RANGE_MELEE,
        talentRow = 7,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["shurikenTornado"] = {
        id = 277925,
        name = HoJ:GetSpellName( 277925 ),
        rank = HoJ:GetSpellRank( 277925 ),
        icon = HoJ:GetSpellIcon( 277925 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = -60,
        _comboGen = 0,
        range = HoJ.RANGE_10_YARDS,
        talentRow = 7,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["blackPowder"] = {
        id = 319175,
        name = HoJ:GetSpellName( 319175 ),
        rank = HoJ:GetSpellRank( 319175 ),
        icon = HoJ:GetSpellIcon( 319175 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 52,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = -6,
        range = HoJ.RANGE_8_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["blackPowder2"] = {
        id = 319178,
        name = HoJ:GetSpellName( 319178 ),
        rank = HoJ:GetSpellRank( 319178 ),
        icon = HoJ:GetSpellIcon( 319178 ),
        _cdId = 319175,
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 58,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = -6,
        range = HoJ.RANGE_8_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
    ["crimsonTempest"] = {
        id = 121411,
        name = HoJ:GetSpellName( 121411 ),
        rank = HoJ:GetSpellRank( 121411 ),
        icon = HoJ:GetSpellIcon( 121411 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = -60,
        _comboGen = 0,
        range = HoJ.RANGE_10_YARDS,
        talentRow = 7,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["hiddenBlades"] = {
        id = 270061,
        name = HoJ:GetSpellName( 270061 ),
        rank = HoJ:GetSpellRank( 270061 ),
        icon = HoJ:GetSpellIcon( 270061 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = -60,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 7,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["subterfuge"] = {
        id = 108208,
        name = HoJ:GetSpellName( 108208 ),
        rank = HoJ:GetSpellRank( 108208 ),
        icon = HoJ:GetSpellIcon( 108208 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = -60,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 2,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["subterfugeBuff"] = {
        id = 115192,
        name = HoJ:GetSpellName( 115192 ),
        rank = HoJ:GetSpellRank( 115192 ),
        icon = HoJ:GetSpellIcon( 115192 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 2,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["blindside"] = {
        id = 328085,
        name = HoJ:GetSpellName( 328085 ),
        rank = HoJ:GetSpellRank( 328085 ),
        icon = HoJ:GetSpellIcon( 328085 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = -60,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 1,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["blindsideBuff"] = {
        id = 121153,
        name = HoJ:GetSpellName( 121153 ),
        rank = HoJ:GetSpellRank( 121153 ),
        icon = HoJ:GetSpellIcon( 121153 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = -60,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["vigor"] = {
        id = 14983,
        name = HoJ:GetSpellName( 14983 ),
        rank = HoJ:GetSpellRank( 14983 ),
        icon = HoJ:GetSpellIcon( 14983 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _powerGen = -60,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 3,
        talentCol = 1,
        _talentSpecs = { HoJ.SPEC_ROGUE_ASSASSINATION },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["ghostlyStrike"] = {
        id = 196937,
        name = HoJ:GetSpellName( 196937 ),
        rank = HoJ:GetSpellRank( 196937 ),
        icon = HoJ:GetSpellIcon( 196937 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 15,
        cooldownRemaining = 0,
        _powerGen = -30,
        _comboGen = 0,
        range = HoJ.RANGE_8_YARDS,
        talentRow = 1,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["preyOnTheWeak"] = {
        id = 131511,
        name = HoJ:GetSpellName( 131511 ),
        rank = HoJ:GetSpellRank( 131511 ),
        icon = HoJ:GetSpellIcon( 131511 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 5,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["dreadblades"] = {
        id = 343142,
        name = HoJ:GetSpellName( 343142 ),
        rank = HoJ:GetSpellRank( 343142 ),
        icon = HoJ:GetSpellIcon( 343142 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _powerGen = -30,
        _comboGen = 0,
        range = HoJ.RANGE_8_YARDS,
        talentRow = 6,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["bladeRush"] = {
        id = 271877,
        name = HoJ:GetSpellName( 271877 ),
        rank = HoJ:GetSpellRank( 271877 ),
        icon = HoJ:GetSpellIcon( 271877 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = 25,
        _comboGen = 0,
        range = HoJ.RANGE_20_YARDS,
        talentRow = 7,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["killingSpree"] = {
        id = 51690,
        name = HoJ:GetSpellName( 51690 ),
        rank = HoJ:GetSpellRank( 51690 ),
        icon = HoJ:GetSpellIcon( 51690 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_10_YARDS,
        talentRow = 7,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["opportunity"] = {
        id = 195627,
        name = HoJ:GetSpellName( 195627 ),
        rank = HoJ:GetSpellRank( 195627 ),
        icon = HoJ:GetSpellIcon( 195627 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 12, -- FIXME: not entirey sure this is when opportunity first starts proccing
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    -- roll the bones UpdateIcons2:
    ["broadside"] = {
        id = 193356,
        name = HoJ:GetSpellName( 193356 ),
        rank = HoJ:GetSpellRank( 193356 ),
        icon = HoJ:GetSpellIcon( 193356 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 29,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["trueBearing"] = {
        id = 193359,
        name = HoJ:GetSpellName( 193359 ),
        rank = HoJ:GetSpellRank( 193359 ),
        icon = HoJ:GetSpellIcon( 193359 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 29,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["ruthlessPrecision"] = {
        id = 193357,
        name = HoJ:GetSpellName( 193357 ),
        rank = HoJ:GetSpellRank( 193357 ),
        icon = HoJ:GetSpellIcon( 193357 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 29,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["skullAndCrossbones"] = {
        id = 199603,
        name = HoJ:GetSpellName( 199603 ),
        rank = HoJ:GetSpellRank( 199603 ),
        icon = HoJ:GetSpellIcon( 199603 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 29,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["buriedTreasure"] = {
        id = 199600,
        name = HoJ:GetSpellName( 199600 ),
        rank = HoJ:GetSpellRank( 199600 ),
        icon = HoJ:GetSpellIcon( 199600 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 29,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["grandMelee"] = {
        id = 199358,
        name = HoJ:GetSpellName( 199358 ),
        rank = HoJ:GetSpellRank( 199358 ),
        icon = HoJ:GetSpellIcon( 199358 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 29,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_OUTLAW },
    },
    ["findWeakness"] = {
        id = 316219,
        name = HoJ:GetSpellName( 316219 ),
        rank = HoJ:GetSpellRank( 316219 ),
        icon = HoJ:GetSpellIcon( 316219 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 60, -- FIXME: not entirey sure this is when opportunity first starts proccing
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
    },
}
